"""
    Apideck

    The Apideck OpenAPI Spec: SDK Optimized  # noqa: E501

    The version of the OpenAPI document: 10.4.2
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from apideck.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from apideck.exceptions import ApiAttributeError


def lazy_import():
    from apideck.model.form_field_option import FormFieldOption
    globals()['FormFieldOption'] = FormFieldOption


class FormField(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('type',): {
            'TEXT': "text",
            'CHECKBOX': "checkbox",
            'TEL': "tel",
            'EMAIL': "email",
            'URL': "url",
            'TEXTAREA': "textarea",
            'SELECT': "select",
            'FILTERED-SELECT': "filtered-select",
            'MULTI-SELECT': "multi-select",
            'DATETIME': "datetime",
            'DATE': "date",
            'TIME': "time",
            'NUMBER': "number",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'label': (str,),  # noqa: E501
            'placeholder': (str, none_type,),  # noqa: E501
            'description': (str, none_type,),  # noqa: E501
            'type': (str,),  # noqa: E501
            'required': (bool,),  # noqa: E501
            'custom_field': (bool,),  # noqa: E501
            'allow_custom_values': (bool,),  # noqa: E501
            'disabled': (bool, none_type,),  # noqa: E501
            'hidden': (bool, none_type,),  # noqa: E501
            'deprecated': (bool, none_type,),  # noqa: E501
            'sensitive': (bool, none_type,),  # noqa: E501
            'prefix': (str, none_type,),  # noqa: E501
            'suffix': (str, none_type,),  # noqa: E501
            'options': ([FormFieldOption],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'label': 'label',  # noqa: E501
        'placeholder': 'placeholder',  # noqa: E501
        'description': 'description',  # noqa: E501
        'type': 'type',  # noqa: E501
        'required': 'required',  # noqa: E501
        'custom_field': 'custom_field',  # noqa: E501
        'allow_custom_values': 'allow_custom_values',  # noqa: E501
        'disabled': 'disabled',  # noqa: E501
        'hidden': 'hidden',  # noqa: E501
        'deprecated': 'deprecated',  # noqa: E501
        'sensitive': 'sensitive',  # noqa: E501
        'prefix': 'prefix',  # noqa: E501
        'suffix': 'suffix',  # noqa: E501
        'options': 'options',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """FormField - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): The unique identifier of the form field.. [optional]  # noqa: E501
            label (str): The label of the field. [optional]  # noqa: E501
            placeholder (str, none_type): The placeholder for the form field. [optional]  # noqa: E501
            description (str, none_type): The description of the form field. [optional]  # noqa: E501
            type (str): [optional]  # noqa: E501
            required (bool): Indicates if the form field is required, which means it must be filled in before the form can be submitted. [optional]  # noqa: E501
            custom_field (bool): [optional]  # noqa: E501
            allow_custom_values (bool): Only applicable to select fields. Allow the user to add a custom value though the option select if the desired value is not in the option select list.. [optional] if omitted the server will use the default value of False  # noqa: E501
            disabled (bool, none_type): Indicates if the form field is displayed in a “read-only” mode.. [optional]  # noqa: E501
            hidden (bool, none_type): Indicates if the form field is not displayed but the value that is being stored on the connection.. [optional]  # noqa: E501
            deprecated (bool, none_type): When the setting is deprecated, it should be hidden from the user interface. The value will still be stored on the connection for the sake of backwards compatibility.. [optional]  # noqa: E501
            sensitive (bool, none_type): Indicates if the form field contains sensitive data, which will display the value as a masked input.. [optional]  # noqa: E501
            prefix (str, none_type): Prefix to display in front of the form field.. [optional]  # noqa: E501
            suffix (str, none_type): Suffix to display next to the form field.. [optional]  # noqa: E501
            options ([FormFieldOption]): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """FormField - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): The unique identifier of the form field.. [optional]  # noqa: E501
            label (str): The label of the field. [optional]  # noqa: E501
            placeholder (str, none_type): The placeholder for the form field. [optional]  # noqa: E501
            description (str, none_type): The description of the form field. [optional]  # noqa: E501
            type (str): [optional]  # noqa: E501
            required (bool): Indicates if the form field is required, which means it must be filled in before the form can be submitted. [optional]  # noqa: E501
            custom_field (bool): [optional]  # noqa: E501
            allow_custom_values (bool): Only applicable to select fields. Allow the user to add a custom value though the option select if the desired value is not in the option select list.. [optional] if omitted the server will use the default value of False  # noqa: E501
            disabled (bool, none_type): Indicates if the form field is displayed in a “read-only” mode.. [optional]  # noqa: E501
            hidden (bool, none_type): Indicates if the form field is not displayed but the value that is being stored on the connection.. [optional]  # noqa: E501
            deprecated (bool, none_type): When the setting is deprecated, it should be hidden from the user interface. The value will still be stored on the connection for the sake of backwards compatibility.. [optional]  # noqa: E501
            sensitive (bool, none_type): Indicates if the form field contains sensitive data, which will display the value as a masked input.. [optional]  # noqa: E501
            prefix (str, none_type): Prefix to display in front of the form field.. [optional]  # noqa: E501
            suffix (str, none_type): Suffix to display next to the form field.. [optional]  # noqa: E501
            options ([FormFieldOption]): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
